/********************************
* Generates botanical form
*********************************/

class botanicalForm{
  
  String axiom;
  String computedWord;
  int size, angle;
  String[][] rules = {{"+", "+"},
                      {"-", "-"},
                      {"[", "["},
                      {"]", "]"},
                      {"F", "F[+F]F[-F][F]"}};
                    
  
 
  botanicalForm(int size, int angle){
    this.size = size;
    this.angle = angle;
    axiom = "FF+F+F+F---";
    computedWord = axiom;
  }
  

  //from class slides
  void iterateB(int iterations){
    String tempWord;
    println("starting word: " +computedWord);
    for(int i=0; i<iterations; i++) {
      tempWord = computedWord;
      computedWord = "";
      for(int j=0; j<tempWord.length();j++) { //loop through word
        char c = tempWord.charAt(j);
        for(int k=0; k<rules.length;k++) { //loop through rules
          if (c==rules[k][0].charAt(0)) {
            computedWord = computedWord + rules[k][1];
            break;
          }
        }
      }
      println("iteration " + i +": " +computedWord);
    }
  }
  
  
  void drawAbstractB(Turtle t){
    for (int i=0; i<computedWord.length(); i++) {
      char c = computedWord.charAt(i);
      if (c == 'F')
        t.forward(size);
      else if (c == 'L')
        t.forward(size);
      else if (c == 'R')
        t.forward(size);
      else if (c == '+')
        t.right(angle);
      else if (c == '-')
        t.left(angle);
      else if (c == '[')
        t.push();
      else if (c == ']')
        t.pop();
    }
  }
  
}
