/********************************
* Rogan Brown inspired cut out
*********************************/

class roganBrown{
  
  String axiom;
  String computedWord;
  String[][] rules = {{"F", "F–F+F+F+F+F+F+F–F"}, {"+", "+"}, {"-", "-"}};
  float size, angle;
  
  
  roganBrown(float size, float angle){
    this.size = size;
    this.angle = angle;
    axiom = "F-F-F-F-F-F-F-F";
    computedWord = axiom;
  }
  
  
void iterateR(int iterations){
    String tempWord;
    println("starting word: " +computedWord);
    for(int i=0; i<iterations; i++) {
      tempWord = computedWord;
      computedWord = "";
      for(int j=0; j<tempWord.length();j++) { //loop through word
        char c = tempWord.charAt(j);
        for(int k=0; k<rules.length;k++) { //loop through rules
          if (c==rules[k][0].charAt(0)) {
            computedWord = computedWord + rules[k][1];
            break;
          }
        }
      }
      println("iteration " + i +": " +computedWord);
    }
  }
  
  
  void drawRogan(Turtle t){
    
    char c;
    for(int i = 0; i<computedWord.length(); i++){
      c = computedWord.charAt(i);
      if(c =='F')
        t.forward(size);
      else if (c == '+')
        t.right(angle);
      else if(c == '-')
        t.left(angle);
    }
  }
  
}
